# Generated by the protocol buffer compiler.  DO NOT EDIT!
# Source: google/cloud/dialogflow/cx/v3/agent.proto for package 'Google.Cloud.Dialogflow.CX.V3'
# Original file comments:
# Copyright 2021 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

require 'grpc'
require 'google/cloud/dialogflow/cx/v3/agent_pb'

module Google
  module Cloud
    module Dialogflow
      module CX
        module V3
          module Agents
            # Service for managing [Agents][google.cloud.dialogflow.cx.v3.Agent].
            class Service

              include GRPC::GenericService

              self.marshal_class_method = :encode
              self.unmarshal_class_method = :decode
              self.service_name = 'google.cloud.dialogflow.cx.v3.Agents'

              # Returns the list of all agents in the specified location.
              rpc :ListAgents, ::Google::Cloud::Dialogflow::CX::V3::ListAgentsRequest, ::Google::Cloud::Dialogflow::CX::V3::ListAgentsResponse
              # Retrieves the specified agent.
              rpc :GetAgent, ::Google::Cloud::Dialogflow::CX::V3::GetAgentRequest, ::Google::Cloud::Dialogflow::CX::V3::Agent
              # Creates an agent in the specified location.
              #
              # Note: You should always train flows prior to sending them queries. See the
              # [training
              # documentation](https://cloud.google.com/dialogflow/cx/docs/concept/training).
              rpc :CreateAgent, ::Google::Cloud::Dialogflow::CX::V3::CreateAgentRequest, ::Google::Cloud::Dialogflow::CX::V3::Agent
              # Updates the specified agent.
              #
              # Note: You should always train flows prior to sending them queries. See the
              # [training
              # documentation](https://cloud.google.com/dialogflow/cx/docs/concept/training).
              rpc :UpdateAgent, ::Google::Cloud::Dialogflow::CX::V3::UpdateAgentRequest, ::Google::Cloud::Dialogflow::CX::V3::Agent
              # Deletes the specified agent.
              rpc :DeleteAgent, ::Google::Cloud::Dialogflow::CX::V3::DeleteAgentRequest, ::Google::Protobuf::Empty
              # Exports the specified agent to a binary file.
              # This method is a [long-running
              # operation](https://cloud.google.com/dialogflow/cx/docs/how/long-running-operation).
              # The returned `Operation` type has the following method-specific fields:
              #
              # - `metadata`: An empty [Struct
              #   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#struct)
              # - `response`: [ExportAgentResponse][google.cloud.dialogflow.cx.v3.ExportAgentResponse]
              rpc :ExportAgent, ::Google::Cloud::Dialogflow::CX::V3::ExportAgentRequest, ::Google::Longrunning::Operation
              # Restores the specified agent from a binary file.
              #
              # Replaces the current agent with a new one. Note that all existing resources
              # in agent (e.g. intents, entity types, flows) will be removed.
              #
              #
              # Note: You should always train flows prior to sending them queries. See the
              # [training
              # documentation](https://cloud.google.com/dialogflow/cx/docs/concept/training).
              rpc :RestoreAgent, ::Google::Cloud::Dialogflow::CX::V3::RestoreAgentRequest, ::Google::Longrunning::Operation
              # Validates the specified agent and creates or updates validation results.
              # The agent in draft version is validated. Please call this API after the
              # training is completed to get the complete validation results.
              rpc :ValidateAgent, ::Google::Cloud::Dialogflow::CX::V3::ValidateAgentRequest, ::Google::Cloud::Dialogflow::CX::V3::AgentValidationResult
              # Gets the latest agent validation result. Agent validation is performed
              # when ValidateAgent is called.
              rpc :GetAgentValidationResult, ::Google::Cloud::Dialogflow::CX::V3::GetAgentValidationResultRequest, ::Google::Cloud::Dialogflow::CX::V3::AgentValidationResult
            end

            Stub = Service.rpc_stub_class
          end
        end
      end
    end
  end
end
